#include <amxmodx>
#include <amxmisc>
#include <xs>

#define MAX_LOCATIONS	100

#define DEFAULT_ORIGIN	9999

#define OFFSET_BOTTOM	-30
#define OFFSET_TOP	80

new const g_sTeamNames[4][] =
{
	"Spectator",
	"Terrorist",
	"Counter-Terrorist",
	"Spectator"
};

new const g_sRadioCode[][] =
{
	"#Cover_me",
	"#Enemy_spotted",
	"#Need_backup",
	"#Sector_clear",
	"#In_position",
	"#Reporting_in",
	"#Get_out_of_there",
	"#Negative",
	"#Enemy_down",
	"#Go_go_go",
	"#Team_fall_back",
	"#Stick_together_team",
	"#Get_in_position_and_wait",
	"#Storm_the_front",
	"#Report_in_team",
	"#You_take_the_point",
	"#Hold_this_position",
	"#Follow_me",
	"#Taking_fire",
	"#Roger_that",
	"#Affirmative"
};

new const g_sRadioText[][] =
{
	"Cover Me!",
	"Enemy spotted.",
	"Need backup.",
	"Sector clear.",
	"I'm in position.",
	"Reporting in.",
	"Get out of there, it's gonna blow!",
	"Negative.",
	"Enemy down.",
	"Go go go!",
	"Team, fall back!",
	"Stick together, team.",
	"Get in position and wait for my go.",
	"Storm the Front!",
	"Report in, team.",
	"You Take the Point.",
	"Hold This Position.",
	"Follow Me.",
	"Taking Fire...Need Assistance!",
	"Roger that.",
	"Affirmative."
};

new const g_iMaxRadioMsgs = sizeof(g_sRadioCode);

new g_sFileName[200];

new g_iCount;
new g_vOrigins[MAX_LOCATIONS][4][3];
new g_sDescriptions[MAX_LOCATIONS][32];
new g_iOriginHeight[MAX_LOCATIONS];

new g_iBeam;

new g_iHeight[33];
new bool:g_bMaking[33];
new g_vTempOrigins[33][4][3];
new g_sLocationName[33][32];

new bool:g_bShowLocation[33][MAX_LOCATIONS];

new g_LocationMenu;
new g_OptionsMenu;

new SayText;
new g_iMaxPlayers;

const Float:g_fLocationShowTime = 1.0;
new g_iLocationLife;

public plugin_precache()
{
	g_iBeam = precache_model("sprites/zbeam4.spr");
	
	new sDataDir[100], sMapName[64];
	get_datadir(sDataDir, sizeof(sDataDir) - 1);
	get_mapname(sMapName, sizeof(sMapName) - 1);
	formatex(g_sFileName, sizeof(g_sFileName) - 1, "%s/%s__locations.txt", sDataDir, sMapName);
	load_locations(false);
}

public plugin_init()
{
	register_plugin("Location Maker", "0.1", "Exolent");
	register_clcmd("amx_location_menu", "concmd_Location_Menu", ADMIN_MENU, "-- Displays location menu.");
	register_clcmd("amx_location_name", "concmd_Location_Name");
	register_clcmd("say_team", "clcmd_SayTeam");
	register_message(get_user_msgid("TextMsg"), "message_TextMsg");
}

public plugin_cfg()
{
	g_LocationMenu = menu_create("Location Menu", "handle_Location_Menu");
	menu_additem(g_LocationMenu, "Start Location Box", "1");
	menu_additem(g_LocationMenu, "Set Location Name", "2");
	menu_additem(g_LocationMenu, "Finish Location Box", "3");
	menu_additem(g_LocationMenu, "Cancel Location Box", "4");
	menu_additem(g_LocationMenu, "Edit Location Box", "5");
	menu_additem(g_LocationMenu, "Show/Hide Location Box", "6");
	menu_addblank(g_LocationMenu, 0);
	menu_additem(g_LocationMenu, "Increase Height", "7");
	menu_additem(g_LocationMenu, "Decrease Height", "8");
	menu_addblank(g_LocationMenu, 0);
	menu_additem(g_LocationMenu, "Options", "9");
	menu_addblank(g_LocationMenu, 0);
	menu_additem(g_OptionsMenu, "Exit", "0");
	menu_setprop(g_LocationMenu, MPROP_PERPAGE, 0);
	
	g_OptionsMenu = menu_create("Location Options", "handle_Options_Menu");
	menu_additem(g_OptionsMenu, "Delete All Locations", "1");
	menu_addblank(g_OptionsMenu, 0);
	menu_additem(g_OptionsMenu, "Load Saved Locations", "2");
	menu_additem(g_OptionsMenu, "Save Locations", "3");
	menu_addblank(g_OptionsMenu, 1);
	menu_addblank(g_OptionsMenu, 1);
	menu_addblank(g_OptionsMenu, 1);
	menu_addblank(g_OptionsMenu, 1);
	menu_addblank(g_OptionsMenu, 1);
	menu_addblank(g_OptionsMenu, 1);
	menu_additem(g_OptionsMenu, "Back", "0");
	menu_setprop(g_OptionsMenu, MPROP_PERPAGE, 0);
	
	SayText = get_user_msgid("SayText");
	g_iMaxPlayers = get_maxplayers();
	
	g_iLocationLife = floatround(g_fLocationShowTime * 10.0);
	set_task(g_fLocationShowTime, "task_ShowLocations", 44221133, _, _, "b");
}

public client_connect(id)
{
	g_iHeight[id] = 0;
	g_bMaking[id] = false;
	arrayset(g_bShowLocation[id], false, sizeof(g_bShowLocation[]));
}

public concmd_Location_Menu(id, level, cid)
{
	if(cmd_access(id, level, cid, 1))
	{
		menu_display(id, g_LocationMenu, 0);
	}
	return PLUGIN_HANDLED;
}

public concmd_Location_Name(id, level, cid)
{
	if(cmd_access(id, level, cid, 2))
	{
		if(g_bMaking[id])
		{
			read_argv(1, g_sLocationName[id], sizeof(g_sLocationName[]) - 1);
			client_print(id, print_chat, "[LOCATION] Set location name to: %s", g_sLocationName[id]);
		}
		else
		{
			client_print(id, print_chat, "[LOCATION] You must be making or editing a location to set a name.");
		}
	}
	return PLUGIN_HANDLED;
}

public clcmd_SayTeam(id)
{
	static sMessage[192];
	read_args(sMessage, sizeof(sMessage) - 1);
	remove_quotes(sMessage);
	if(!strlen(sMessage) || sMessage[0] == '@')
	{
		return PLUGIN_CONTINUE;
	}
	
	static iNum;
	iNum = get_user_location(id);
	if(iNum == -1)
	{
		return PLUGIN_CONTINUE;
	}
	
	static sName[32];
	get_user_name(id, sName, sizeof(sName) - 1);
	
	static alive[33];
	alive[id] = is_user_alive(id);
	
	static team[33];
	team[id] = get_user_team(id);
	
	static sNewMessage[sizeof(sMessage)];
	formatex(sNewMessage, sizeof(sNewMessage) - 1, "^x01%s(%s)^x03 %s^x01 @^x04 %s^x01 :  %s", alive ? "" : "*DEAD*", g_sTeamNames[team[id]], sName, g_sDescriptions[iNum], sMessage);
	
	static player;
	for(player = 1; player <= g_iMaxPlayers; player++)
	{
		if(is_user_connected(player) && (is_user_alive(player) == alive[id]) && (get_user_team(player) == team[id]))
		{
			make_SayText(id, player, sNewMessage);
		}
	}
	return PLUGIN_HANDLED;
}

public message_TextMsg(msgid, dest, id)
{
	if(get_msg_args() != 5)
	{
		return PLUGIN_CONTINUE;
	}
	
	static const sRadioArg[] = "#Game_radio";
	static sArg3[sizeof(sRadioArg)];
	get_msg_arg_string(3, sArg3, sizeof(sArg3) - 1);
	if(!equali(sArg3, sRadioArg))
	{
		return PLUGIN_CONTINUE;
	}
	
	static sRadioCode[26];
	get_msg_arg_string(5, sRadioCode, sizeof(sRadioCode) - 1);
	
	static iRadioNum;
	iRadioNum = get_radio_num(sRadioCode);
	if(iRadioNum == 0)
	{
		return PLUGIN_CONTINUE;
	}
	
	static sPlayer[3], player;
	get_msg_arg_string(2, sPlayer, sizeof(sPlayer) - 1);
	player = str_to_num(sPlayer);
	if(!is_user_connected(player))
	{
		return PLUGIN_CONTINUE;
	}
	
	static sName[32];
	get_msg_arg_string(4, sName, sizeof(sName) - 1);
	
	static sMessage[192];
	
	static iNum;
	iNum = get_user_location(player);
	if(iNum == -1)
	{
		formatex(sMessage, sizeof(sMessage) - 1, "^x03%s^x01 (RADIO): %s", sName, g_sRadioText[iRadioNum]);
	}
	else
	{
		formatex(sMessage, sizeof(sMessage) - 1, "^x03%s^x01 @^x04 %s^x01 (RADIO): %s", sName, g_sDescriptions[iNum], g_sRadioText[iRadioNum]);
	}
	
	static i;
	for(i = 1; i <= g_iMaxPlayers; i++)
	{
		if(is_user_connected(i) && !is_user_bot(i))
		{
			make_SayText(id, player, sMessage);
		}
	}
	return PLUGIN_HANDLED;
}

public handle_Location_Menu(id, menu, item)
{
	new sNum[3], iAccess, iCallback;
	menu_item_getinfo(menu, item, iAccess, sNum, sizeof(sNum) - 1, "", 0, iCallback);
	switch(sNum[0])
	{
		case '1':	// start location
		{
			if(g_iCount == MAX_LOCATIONS)
			{
				client_print(id, print_chat, "[LOCATION] Max locations have been reached.");
			}
			else
			{
				g_bMaking[id] = true;
				get_user_origin(id, g_vTempOrigins[id][0], 0);
				client_print(id, print_chat, "[LOCATION] Started location box.");
				
				static const param[4] = {1, 255, 0, 0};
				set_task(0.1, "task_DrawBox", id, param, sizeof(param));
			}
		}
		case '2':	// set location name
		{
			if(g_bMaking[id])
			{
				client_cmd(id, "messagemode amx_location_name");
			}
		}
		case '3':	// finish location
		{
			if(g_bMaking[id])
			{
				if(!strlen(g_sLocationName[id]))
				{
					client_print(id, print_chat, "[LOCATION] You must first set a location name.");
				}
				else
				{
					save_location_box(id);
				}
			}
		}
		case '4':	// cancel location
		{
			if(g_bMaking[id])
			{
				client_print(id, print_chat, "[LOCATION] Cancelled location box.");
				for(new i = 0; i < 4; i++)
				{
					arrayset(g_vTempOrigins[id][i], DEFAULT_ORIGIN, sizeof(g_vTempOrigins[][]));
				}
				g_bMaking[id] = false;
				g_iHeight[id] = 0;
				g_sLocationName[id][0] = '^0';
			}
		}
		case '5':	// edit location
		{
			new iNum = get_user_location(id);
			if(iNum == -1)
			{
				client_print(id, print_chat, "[LOCATION] You must be inside a location to edit one.");
			}
			else
			{
				client_print(id, print_chat, "[LOCATION] Now editing location: %s", g_sDescriptions[iNum]);
				
				g_bMaking[id] = true;
				g_iHeight[id] = g_iOriginHeight[iNum];
				formatex(g_sLocationName[id], sizeof(g_sLocationName[]) - 1, "%s", g_sDescriptions[iNum]);
				
				new a, b;
				for(a = 0; a < 4; a++)
				{
					for(b = 0; b < 3; b++)
					{
						g_vTempOrigins[id][a][b] = g_vOrigins[iNum][a][b];
					}
				}
				new c, id;
				for(a = iNum; a < g_iCount; a++)
				{
					if((a + 1) == g_iCount)
					{
						for(b = 0; b < 4; b++)
						{
							for(c = 0; c < 3; c++)
							{
								g_vOrigins[a][b][c] = DEFAULT_ORIGIN;
							}
						}
						g_sDescriptions[a][0] = '^0';
						g_iOriginHeight[a] = 0;
						for(id = 1; id <= g_iMaxPlayers; id++)
						{
							g_bShowLocation[a][id] = false;
						}
					}
					else
					{
						for(b = 0; b < 4; b++)
						{
							for(c = 0; c < 3; c++)
							{
								g_vOrigins[a][b][c] = g_vOrigins[a + 1][b][c];
							}
						}
						formatex(g_sDescriptions[a], sizeof(g_sDescriptions[]) - 1, "%s", g_sDescriptions[a + 1]);
						g_iOriginHeight[a] = g_iOriginHeight[a + 1];
						for(id = 1; id <= g_iMaxPlayers; id++)
						{
							g_bShowLocation[a][id] = g_bShowLocation[a + 1][id];
						}
					}
				}
				
				g_iCount--;
				
				static const param[4] = {0, 255, 255, 0};
				set_task(0.1, "task_DrawBox", id, param, sizeof(param));
			}
		}
		case '6':	// show/hide location box
		{
			new iNum = get_user_location(id);
			if(iNum == -1)
			{
				client_print(id, print_chat, "[LOCATION] You must be inside a location to show/hide one.");
			}
			else
			{
				if(g_bShowLocation[id][iNum])
				{
					client_print(id, print_chat, "[LOCATION] Location is now hidden. (%s)", g_sDescriptions[iNum]);
				}
				else
				{
					client_print(id, print_chat, "[LOCATION] Location is now shown. (%s)", g_sDescriptions[iNum]);
				}
				g_bShowLocation[id][iNum] = !g_bShowLocation[id][iNum];
			}
		}
		case '7':	// increase height
		{
			if(g_bMaking[id])
			{
				g_iHeight[id] += 5;
			}
		}
		case '8':	// decrease height
		{
			if(g_bMaking[id])
			{
				g_iHeight[id] -= 5;
			}
		}
		case '9':
		{
			menu_display(id, g_OptionsMenu, 0);
			return PLUGIN_HANDLED;
		}
		default:
		{
			return PLUGIN_HANDLED;
		}
	}
	menu_display(id, g_LocationMenu, 0);
	return PLUGIN_HANDLED;
}

public handle_Options_Menu(id, menu, item)
{
	new sNum[3], iAccess, iCallback;
	menu_item_getinfo(menu, item, iAccess, sNum, sizeof(sNum) - 1, "", 0, iCallback);
	switch(sNum[0])
	{
		case '1':	// delete all locations
		{
			if(g_iCount == 0)
			{
				client_print(id, print_chat, "[LOCATION] No locations are present.");
			}
			else
			{
				delete_all_locations();
				client_print(id, print_chat, "[LOCATION] All locations deleted.");
			}
		}
		case '2':	// load locations
		{
			if(!file_exists(g_sFileName))
			{
				client_print(id, print_chat, "[LOCATION] Location file was not found.");
			}
			else
			{
				load_locations(true);
				client_print(id, print_chat, "[LOCATION] Loaded %d locations.", g_iCount);
			}
		}
		case '3':	// save locations
		{
			save_locations();
			client_print(id, print_chat, "[LOCATION] Saved all locations.");
		}
		default:
		{
			menu_display(id, g_LocationMenu, 0);
			return PLUGIN_HANDLED;
		}
	}
	menu_display(id, g_OptionsMenu, 0);
	return PLUGIN_HANDLED;
}

public task_DrawBox(param[], id)
{
	if(param[0])
	{
		get_user_origin(id, g_vTempOrigins[id][2], 0);
		g_vTempOrigins[id][2][2] = g_vTempOrigins[id][0][2];
		
		set_box_corners(g_vTempOrigins[id]);
	}
	
	draw_location_box(0, g_vTempOrigins[id], g_iHeight[id], param[1], param[2], param[3], 1);
	
	if(g_bMaking[id])
	{
		static i, newparam[4];
		for(i = 0; i < sizeof(newparam); i++)
		{
			newparam[i] = param[i];
		}
		set_task(0.1, "task_DrawBox", id, newparam, sizeof(newparam));
	}
}

public task_ShowLocations()
{
	if(g_iCount == 0)
	{
		return;
	}
	
	static a, id;
	for(a = 0; a < g_iCount; a++)
	{
		for(id = 1; id <= g_iMaxPlayers; id++)
		{
			if(is_user_connected(id) && g_bShowLocation[a][id])
			{
				draw_location_box(id, g_vOrigins[a], g_iOriginHeight[a], 0, 255, 0, g_iLocationLife);
			}
		}
	}
}

stock get_radio_num(const sRadioCode[])
{
	static i;
	for(i = 1; i < g_iMaxRadioMsgs; i++)
	{
		if(equali(g_sRadioCode[i], sRadioCode))
		{
			return i;
		}
	}
	return 0;
}

stock delete_all_locations()
{
	new a;
	for(new i = 0; i < g_iCount; i++)
	{
		for(a = 0; a < 4; a++)
		{
			arrayset(g_vOrigins[i][a], DEFAULT_ORIGIN, sizeof(g_vOrigins[][]));
		}
		g_sDescriptions[i][0] = '^0';
		g_iOriginHeight[i] = 0;
		arrayset(g_bShowLocation[i], false, sizeof(g_bShowLocation[]));
	}
	g_iCount = 0;
	return 1;
}

stock set_box_corners(vOrigins[4][3])
{
	vOrigins[1][0] = vOrigins[0][0];
	vOrigins[1][1] = vOrigins[2][1];
	vOrigins[3][0] = vOrigins[2][0];
	vOrigins[3][1] = vOrigins[0][1];
	return 1;
}

stock save_locations()
{
	if(file_exists(g_sFileName))
	{
		delete_file(g_sFileName);
	}
	
	if(g_iCount == 0)
	{
		return 1;
	}
	
	new sData[512], sDescription[32], iDescriptionLen = sizeof(sDescription) - 1;
	for(new i = 0; i < g_iCount; i++)
	{
		copy(sDescription, iDescriptionLen, g_sDescriptions[i]);
		replace_all(sDescription, iDescriptionLen, " ", "~");
		formatex(sData, sizeof(sData) - 1, "%d %d %d %d %d %d %d %s",\
			g_vOrigins[i][0][0], g_vOrigins[i][0][1], g_vOrigins[i][0][2],\
			g_vOrigins[i][2][0], g_vOrigins[i][2][1], g_vOrigins[i][2][2],\
			g_iOriginHeight[i], sDescription);
		
		write_file(g_sFileName, sData, -1);
	}
	return 1;
}

stock load_locations(bool:bDeleteAll)
{
	if(bDeleteAll)
	{
		delete_all_locations();
	}
	
	if(!file_exists(g_sFileName))
	{
		return 0;
	}
	
	new sData[512];
	new sOrigins[2][3][16];
	new sHeight[16];
	new sDescription[32];
	
	new iDataLen = sizeof(sData) - 1;
	new iOriginLen = sizeof(sOrigins[][]) - 1;
	new iHeightLen = sizeof(sHeight) - 1;
	new iDescriptionLen = sizeof(sDescription) - 1;
	
	new a, b, c;
	
	new file = fopen(g_sFileName, "rt");
	do
	{
		fgets(file, sData, iDataLen);
		parse(sData,\
			sOrigins[0][0], iOriginLen, sOrigins[0][1], iOriginLen, sOrigins[0][2], iOriginLen,\
			sOrigins[1][0], iOriginLen, sOrigins[1][1], iOriginLen, sOrigins[1][2], iOriginLen,\
			sHeight, iHeightLen, sDescription, iDescriptionLen);
		
		for(a = 0; a < 2; a++)
		{
			c = a * 2;
			for(b = 0; b < 3; b++)
			{
				g_vOrigins[g_iCount][c][b] = str_to_num(sOrigins[a][b]);
			}
		}
		set_box_corners(g_vOrigins[g_iCount]);
		g_iOriginHeight[g_iCount] = str_to_num(sHeight);
		replace_all(sDescription, iDescriptionLen, "~", " ");
		copy(g_sDescriptions[g_iCount], sizeof(g_sDescriptions[]) - 1, sDescription);
		g_iCount++;
	}
	while(!feof(file) && g_iCount < MAX_LOCATIONS)
	return 1;
}

stock get_user_location(id)
{
	new vOrigin[3];
	get_user_origin(id, vOrigin, 0);
	
	new i, j;
	new bool:bInsideLocation[3] = {false, ...};
	
	new a = -1;
	for(i = 0; i < g_iCount; i++)
	{
		for(j = 0; j < 2; j++)
		{
			if(g_vOrigins[i][0][j] < g_vOrigins[i][2][j])
			{
				if((g_vOrigins[i][0][j] - 1) <= vOrigin[j] <= (g_vOrigins[i][2][j] + 1))
				{
					bInsideLocation[j] = true;
				}
			}
			else
			{
				if((g_vOrigins[i][2][j] - 1) <= vOrigin[j] <= (g_vOrigins[i][0][j] + 1))
				{
					bInsideLocation[j] = true;
				}
			}
		}
		if((g_vOrigins[i][0][2] + OFFSET_TOP + g_iOriginHeight[i]) >= vOrigin[2] >= (g_vOrigins[i][0][2] + OFFSET_BOTTOM))
		{
			bInsideLocation[2] = true;
		}
		
		if(bInsideLocation[0] && bInsideLocation[1] && bInsideLocation[2])
		{
			a = i;
			break;
		}
		arrayset(bInsideLocation, false, sizeof(bInsideLocation));
	}
	return a;
}

stock save_location_box(id)
{
	if(!g_bMaking[id])
	{
		return 0;
	}
	
	new a;
	for(new i = 0; i < 4; i++)
	{
		for(a = 0; a < 3; a++)
		{
			g_vOrigins[g_iCount][i][a] = g_vTempOrigins[id][i][a];
		}
		arrayset(g_vTempOrigins[id][i], DEFAULT_ORIGIN, sizeof(g_vTempOrigins[][]));
	}
	
	formatex(g_sDescriptions[g_iCount], sizeof(g_sDescriptions[]) - 1, "%s", g_sLocationName[id]);
	g_iOriginHeight[g_iCount] = g_iHeight[id];
	g_iCount++;
	
	g_bMaking[id] = false;
	g_iHeight[id] = 0;
	g_sLocationName[id][0] = '^0';
	
	client_print(id, print_chat, "[LOCATION] Finished location box. Name: %s", g_sDescriptions[g_iCount - 1]);
	return 1;
}

stock draw_location_box(const index, const vOrigins[4][3], const iHeight, const iRed, const iGreen, const iBlue, const iLife)
{
	static a, b;
	static iOffset[2];
	iOffset[0] = OFFSET_BOTTOM;
	iOffset[1] = OFFSET_TOP + iHeight;
	for(a = 0; a < 2; a++)
	{
		for(b = 0; b < 4; b++)
		{
			if(b < 3)
			{
				make_BeamPoints(index, vOrigins[b][0], vOrigins[b][1], (vOrigins[0][2] + iOffset[a]), vOrigins[b + 1][0], vOrigins[b + 1][1], (vOrigins[0][2] + iOffset[a]), iRed, iGreen, iBlue, iLife);
				//make_BeamPoints(index, vOrigins[b][0], vOrigins[b][1], (vOrigins[0][2] + iOffset[0]), vOrigins[b + 1][0], vOrigins[b + 1][1], (vOrigins[0][2] + iOffset[1]), iRed, iGreen, iBlue, iLife);
				//make_BeamPoints(index, vOrigins[b][0], vOrigins[b][1], (vOrigins[0][2] + iOffset[1]), vOrigins[b + 1][0], vOrigins[b + 1][1], (vOrigins[0][2] + iOffset[0]), iRed, iGreen, iBlue, iLife);
			}
			else
			{
				make_BeamPoints(index, vOrigins[b][0], vOrigins[b][1], (vOrigins[0][2] + iOffset[a]), vOrigins[0][0], vOrigins[0][1], (vOrigins[0][2] + iOffset[a]), iRed, iGreen, iBlue, iLife);
				//make_BeamPoints(index, vOrigins[b][0], vOrigins[b][1], (vOrigins[0][2] + iOffset[0]), vOrigins[0][0], vOrigins[0][1], (vOrigins[0][2] + iOffset[1]), iRed, iGreen, iBlue, iLife);
				//make_BeamPoints(index, vOrigins[b][0], vOrigins[b][1], (vOrigins[0][2] + iOffset[1]), vOrigins[0][0], vOrigins[0][1], (vOrigins[0][2] + iOffset[0]), iRed, iGreen, iBlue, iLife);
			}
			if(a == 0)
			{
				make_BeamPoints(index, vOrigins[b][0], vOrigins[b][1], (vOrigins[0][2] + iOffset[0]), vOrigins[b][0], vOrigins[b][1], (vOrigins[0][2] + iOffset[1]), iRed, iGreen, iBlue, iLife);
			}
			//make_BeamPoints(index, vOrigins[a][0], vOrigins[a][1], (vOrigins[0][2] + iOffset[0]), vOrigins[a + 2][0], vOrigins[a + 2][1], (vOrigins[0][2] + iOffset[0]), iRed, iGreen, iBlue, iLife);
			//make_BeamPoints(index, vOrigins[a][0], vOrigins[a][1], (vOrigins[0][2] + iOffset[1]), vOrigins[a + 2][0], vOrigins[a + 2][1], (vOrigins[0][2] + iOffset[1]), iRed, iGreen, iBlue, iLife);
		}
	}
	return 1;
}

stock make_BeamPoints(const index, const x1, const y1, const z1, const x2, const y2, const z2, const iRed, const iGreen, const iBlue, const iLife)
{
	message_begin(is_user_connected(index) ? MSG_ONE_UNRELIABLE : MSG_BROADCAST, SVC_TEMPENTITY);
	write_byte(TE_BEAMPOINTS);	// write_byte(TE_BEAMPOINTS)
	write_coord(x1);		// write_coord(startposition.x)
	write_coord(y1);		// write_coord(startposition.y)
	write_coord(z1);		// write_coord(startposition.z)
	write_coord(x2);		// write_coord(endposition.x)
	write_coord(y2);		// write_coord(endposition.y)
	write_coord(z2);		// write_coord(endposition.z)
	write_short(g_iBeam);		// write_short(sprite index) 
	write_byte(0);			// write_byte(starting frame) 
	write_byte(0);			// write_byte(frame rate in 0.1's) 
	write_byte(iLife);		// write_byte(life in 0.1's) 
	write_byte(15);			// write_byte(line width in 0.1's) 
	write_byte(0);			// write_byte(noise amplitude in 0.01's) 
	write_byte(iRed);		// write_byte(red)
	write_byte(iGreen);		// write_byte(green)
	write_byte(iBlue);		// write_byte(blue)
	write_byte(255);		// write_byte(brightness)
	write_byte(0);			// write_byte(scroll speed in 0.1's)
	message_end();
	return 1;
}

stock make_SayText(sender, receiver, const sMessage[])
{
	static MSG_type, id;
	if(receiver > 0)
	{
		MSG_type = MSG_ONE_UNRELIABLE;
		id = receiver;
	}
	else
	{
		MSG_type = MSG_BROADCAST;
		id = sender;
	}
	
	message_begin(MSG_type, SayText, _, id);
	write_byte(sender);
	write_string(sMessage);
	message_end();
	
	return 1;
}
